mov = avifile('example.avi');

NN = 101;
th = linspace(0,2*pi,NN);
figure(1);
QQ = [2,1;1,5];
cc = [-45;45];
unitC = [ [cos(th); sin(th)] ]*1;
xopt = -QQ\cc;

NN = size(unitC,2);
level1 = [ (0.5*(QQ\unitC) + xopt*ones(1,NN)), ...
          ( 2*(QQ\unitC) + xopt*ones(1,NN)), ...
          ( 4*(QQ\unitC) + xopt*ones(1,NN)), ...
          ( 6*(QQ\unitC) + xopt*ones(1,NN)), ...
          ( 8*(QQ\unitC) + xopt*ones(1,NN)) ];

xlo = 24; xhi = 36; xx = linspace(24,36,25);
ylo = -20; yhi = -8; yy = linspace(ylo, yhi, 25);
for ii=1:length(xx)
  for jj=1:length(yy);
    xv = [xx(ii); yy(jj)];
    cv(jj,ii) = xv'*QQ*xv/2 + cc'*xv - ( xopt'*QQ*xopt/2 + cc'*xopt);
  end
end

meshc(xx,yy,cv);
title('cost function');
xlabel('x value');
ylabel('yvalue');
print -djpeg90 -r0 myframe.jpg
stop

xx = ([0;60]-xopt)/40 + xopt;

nstps = 100;
for eta = [0.02, 0.35];
  clear xdata
  for ii=1:nstps
    fprintf('%s %d \n',datestr(now),ii);
    xdata(:,ii) = xx;
    gg = QQ*xx + cc;
    xpg = xx-gg;
    
    plot( xdata(1,:),xdata(2,:),'-', ...
         level1(1,:),level1(2,:),'-', ...
         [xx(1);xpg(1)],[xx(2);xpg(2)],'-', ...
         xx(1),xx(2),'o');
    legend('trajectory','level curves','gradient','current location');
    axis('equal');
    axis([24,36,-20,-8]);
  
    grid on
    xlabel('x1');
    ylabel('x2');
  
    if(eta > 0.1 )
      if(abs(ii - 5*round(ii/5)) <= 0.5)
        xx = xx-eta*gg;
      end
    else
      if( ii > 15 )
        xx = xx-eta*gg;
      end
    end
    tstr = (sprintf('%4d: eta = %g: cost = %12.4e',ii, eta, ...
      xx'*QQ*xx/2+cc'*xx - (xopt'*QQ*xopt/2 + cc'*xopt)));
    text(24.5,-9,tstr);
  
    %A = imread('myframe.jpg','jpg');
    A = getframe;
    mov = addframe(mov,A);
  
  
  end
  fprintf('%s\n',datestr(now));
  mov = close(mov);
end
