clear
clc

nn = 4; %number of images in the sequence
for ii = 1:nn
s = sprintf('gbe%d.jpg',ii);
[input,map] = imread(s,'jpeg');
dummy = rgb2ind(input,gray(256));
E(:,:,ii) = dummy;
end

[M, N, sizek]=size(E);
%M = number of rows (indexed by ii)
%N = number of columsn (indexed by jj)
u = zeros(M,N);
v = zeros(M,N);

alpha = 20; %weighting factor
num_its = 8; %number of iterations

for kk = 1:sizek-1
    Ex = zeros(M-1,N-1,sizek-1);
    Ey = Ex;
    Et = Ey;
    for ii = 2:M-1
        for jj = 2:N-1
            Ex(ii,jj,kk) = (1/4)*(E(ii+1,jj+1,kk)-E(ii+1,jj,kk)+E(ii,jj+1,kk)-E(ii,jj,kk)...
                +E(ii+1,jj+1,kk+1)-E(ii+1,jj,kk+1)+E(ii,jj+1,kk+1)-E(ii,jj,kk+1));
            Ey(ii,jj,kk) = (1/4)*(E(ii,jj,kk)-E(ii+1,jj,kk)+E(ii,jj+1,kk)-E(ii+1,jj+1,kk)...
                +E(ii,jj,kk+1)-E(ii+1,jj,kk+1)+E(ii,jj+1,kk+1)-E(ii+1,jj+1,kk+1));
            Et(ii,jj,kk) = (1/4)*(E(ii+1,jj,kk+1)-E(ii+1,jj,kk)+E(ii,jj,kk+1)-E(ii,jj,kk)...
                +E(ii+1,jj+1,kk+1)-E(ii+1,jj+1,kk)+E(ii,jj+1,kk+1)-E(ii,jj+1,kk));

        end
    end
end

xkern(:,:,1) = (1/4)*[-1,1;-1,1];
xkern(:,:,2) = xkern(:,:,1);
ykern(:,:,1) = (1/4)*[1,1;-1,-1];
ykern(:,:,2) = ykern(:,:,1);
tkern(:,:,1) = (1/4)*[-1,-1;-1,-1];
tkern(:,:,2) = -tkern(:,:,1);


LaplKern = [1/12,1/6,1/12;1/6,-1,1/6;1/12,1/6,1/12];

Ex2 = convn(E,xkern,'valid');
Ey2 = convn(E,ykern,'valid');
Et2 = convn(E,tkern,'valid');

T = abs(Et - Et2);
X = abs(Ex - Ex2);
Y = abs(Ey - Ey2);

figure(1)
subplot(3,1,1)
mesh(T(:,:,1))
subplot(3,1,2)
mesh(T(:,:,2))
subplot(3,1,3)
mesh(T(:,:,3))

figure(2)
subplot(3,1,1)
mesh(X(:,:,1))
subplot(3,1,2)
mesh(X(:,:,2))
subplot(3,1,3)
mesh(X(:,:,3))

figure(3)
subplot(3,1,1)
mesh(Y(:,:,1))
subplot(3,1,2)
mesh(Y(:,:,2))
subplot(3,1,3)
mesh(Y(:,:,3))