clear
clc
close all


%===frames 1-4===================
nn = 4;
for ii = 1:nn
    s = sprintf('gbe%d.jpg',ii);
    [input,map] = imread(s,'jpeg');
    dummy = rgb2ind(input,gray(256));
    E(:,:,ii) = dummy;
end

[M, N, sizek]=size(E);
%M = number of rows (indexed by ii)
%N = number of columsn (indexed by jj)
u = zeros(M,N);
v = zeros(M,N);

LaplKern = [1/12,1/6,1/12;1/6,-1,1/6;1/12,1/6,1/12];

alpha = 20; %weighting factor
num_its = 32; %number of iterations

for kk = 1:sizek-1
    Ex = zeros(M-1,N-1,sizek-1);
    Ey = Ex;
    Et = Ey;
    for ii = 2:M-1
        for jj = 2:N-1
            Ex(ii,jj,kk) = (1/4)*(E(ii+1,jj+1,kk)-E(ii+1,jj,kk)+E(ii,jj+1,kk)-E(ii,jj,kk)...
                +E(ii+1,jj+1,kk+1)-E(ii+1,jj,kk+1)+E(ii,jj+1,kk+1)-E(ii,jj,kk+1));
            Ey(ii,jj,kk) = (1/4)*(E(ii,jj,kk)-E(ii+1,jj,kk)+E(ii,jj+1,kk)-E(ii+1,jj+1,kk)...
                +E(ii,jj,kk+1)-E(ii+1,jj,kk+1)+E(ii,jj+1,kk+1)-E(ii+1,jj+1,kk+1));
            Et(ii,jj,kk) = (1/4)*(E(ii+1,jj,kk+1)-E(ii+1,jj,kk)+E(ii,jj,kk+1)-E(ii,jj,kk)...
                +E(ii+1,jj+1,kk+1)-E(ii+1,jj+1,kk)+E(ii,jj+1,kk+1)-E(ii,jj+1,kk));

        end
    end


    for nn = 1:num_its
        for ii = 2:M-1
            for jj = 2:N-1

                ubar = (1/6)*(u(ii-1,jj)+u(ii,jj+1)+u(ii+1,jj)+u(ii,jj-1))+...
                    (1/12)*(u(ii-1,jj-1)+u(ii-1,jj+1)+u(ii+1,jj+1)+u(ii+1,jj-1));
                vbar = (1/6)*(v(ii-1,jj)+v(ii,jj+1)+v(ii+1,jj)+v(ii,jj-1))+...
                    (1/12)*(v(ii-1,jj-1)+v(ii-1,jj+1)+v(ii+1,jj+1)+v(ii+1,jj-1));

                %-------------------------
                %compute alpha
                lambda = (Ex(ii,jj,kk)*ubar+Ey(ii,jj,kk)*vbar+Et(ii,jj,kk))/...
                    (alpha^2 +(Ex(ii,jj,kk))^2+(Ey(ii,jj,kk))^2);
                %update u(ii,jj) and v(ii,jj)
                u(ii,jj) = ubar-lambda*Ex(ii,jj,kk);
                v(ii,jj) = vbar-lambda*Ey(ii,jj,kk);
            end
        end
    end
end


dd = 5;
[xx,yy] = meshgrid(1:dd:N,1:dd:M); %creates grid
a = u(1:dd:M,1:dd:N);
b = v(1:dd:M,1:dd:N);
axis ij
quiver(xx,-yy,-b,a,'k')

