%Josh Clanton
%H&S optical flow test code
%4/4/05

clear
clc
close all

dd = 5;
alpha = 20; %weighting factor
num_its = 16; %number of iterations
filename = 'sphere%d.jpg'; %base filename of image sequence
img_num = 4; %number of images in sequence
img_start = 0;%image where computation starts
numperof = 4; %number of images per optical flow calculation


nn = 0;
fignum = 1;
while nn < img_num
    for ii = 1:numperof
        p = nn+ii+img_start;
        s = sprintf(filename,p);
        [input,map] = imread(s,'jpeg');
        dummy = rgb2ind(input,gray(256));
        E(:,:,ii) = dummy;
    end
    [M, N, sizek]=size(E);
    u = zeros(M,N);
    v = zeros(M,N);
    [uu,vv]=hsof(E,num_its,alpha,u,v);
    figure(fignum)
    [xx,yy] = meshgrid(1:dd:N,1:dd:M); %creates grid
    a = uu(1:dd:M,1:dd:N);
    b = vv(1:dd:M,1:dd:N);
    axis ij
    quiver(xx,-yy,-b,a,'k')
    nn = nn + numperof;
    eval(sprintf('print -depsc sphere_of%d',fignum))
    fignum = fignum+1;
end

